<template>
    <MenuBar>
        <div class="login-container">
            <el-card v-loading="loading" class="login-card">
                <h2 class="no-margin">Verify Account</h2>
                <p>
                    Thank you for joining our platform. Before you can proceed,
                    it is important to verify your account. Verification helps
                    us ensure the security and authenticity of our users. Please
                    complete the verification process to unlock the full
                    functionality of our system.
                </p>

                <el-tabs v-model="activeName" class="demo-tabs">
                    <el-tab-pane label="Verify via Email" name="first">
                        <h3>Send a verification code to: {{ data.email }}</h3>
                        <el-button size="large"  @click="getVerificationCode('email')"
                            >Get the code</el-button
                        >

                        <el-input
                            class="margin-top-md"
                            v-model="verificationCode"
                            placeholder="Enter verification code"
                            size="large"
                        ></el-input>
                        <el-button
                            class="margin-top-sm"
                            size="large"
                            @click="checkVerificationCode"
                            >Verify now</el-button
                        >
                    </el-tab-pane>
                    <el-tab-pane label="Verify via SMS" name="second">
                        <h3>
                            Send a verification code to: {{ data.phone_number }}
                        </h3>
                        <el-button size="large"  @click="getVerificationCode('sms')"
                            >Get the code</el-button
                        >

                        <el-input
                            class="margin-top-md"
                            v-model="verificationCode"
                            placeholder="Enter verification code"
                            size="large"
                        ></el-input>
                        <el-button
                            class="margin-top-sm"
                            @click="checkVerificationCode"
                            size="large"
                            >Verify now</el-button
                        >
                    </el-tab-pane>
                </el-tabs>
            </el-card>
        </div>
    </MenuBar>
</template>

<style lang="scss" scoped>
@import "../../../../sass/app.scss";

img {
    cursor: pointer;
}

p {
    text-align: justify;
}

.login-container {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 800px;
}

.login-card {
    width: 400px;
    max-width: 90%;
    padding: 20px;
    --el-card-border-color: none;
}

.el-button {
    --el-button-hover-bg-color: none;
}


</style>

<script setup>
import axios from 'axios'
import { ref, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import userValidator from "../../helpers/userValidator";
import userHandler from "../../helpers/userHandler";
import {notify} from '../../common/notification';

const { getUserData } = userHandler;
const { validateEmail } = userValidator;
const route = useRoute();
const router = useRouter();
const data = ref([]);
const loading = ref(false);
const verificationCode = ref();

const activeName = ref("first");

const getVerificationCode = async (method) => {
    window.axios.defaults.headers.common['Authorization'] =
  `Bearer ${localStorage.getItem('user_token') ?? sessionStorage.getItem('user_token')}`

  const URL_sendCode = '/api/user/send-verification';
  try{
    loading.value = true;
    const response = await axios({
        method: 'POST',
        url: URL_sendCode,
        data: {'method' : method}
    })
    console.log(response);
    notify( response?.data?.status ?? "Success!", response?.data?.message ?? "Your request was successful.", 1);
    }catch(error){
        notify("Error", error?.response?.data?.message ?? "Something went wrong.", 4);
    }finally{
        loading.value = false;
    }
}

const checkVerificationCode = async () => {
    window.axios.defaults.headers.common['Authorization'] =
    `Bearer ${localStorage.getItem('user_token') ?? sessionStorage.getItem('user_token')}`

    const URL_checkCode = '/api/user/check-verification';
    try{
        loading.value = true;
        const response = await axios({
            method: 'POST',
            url: URL_checkCode,
            data: {'verification_code' : verificationCode.value}
        })
        notify( response?.data?.status ?? "Success!", response?.data?.message ?? "Your request was successful.", 1);
        if(response.status == 200){
            router.push('/');
        }
        }catch(error){
            notify("Error", error?.response?.data?.message ?? "Something went wrong.", 4);
        }finally{
            loading.value = false;
            verificationCode.value = '';
        } 
}

onMounted(async () => {
    await validateEmail(router, route);
    await getUserData(data);

});
</script>
